//genesis
echo " "
echo "**********************************************"
echo "*             PIRIFORM CORTEX                *"
echo "*                                            *"
echo "*         Written by Matt Wilson             *"
echo "*  Graphical Interface by Alex Protopapas    *"
echo "*    California Institute of Technology      *"
echo "*                                            *"
echo "*         GENESIS implementation             *"
echo "*                 8/18/93                    *"
echo "**********************************************"
echo " "

clean -f

include xstartup.g
include startup.g		// set up some basic things
include constants.g		// set local variables 
include protodefs.g		// create some prototype objects
include functions.g		// set up some functions
include cells.g			// set up the cells
include pyramidal.g		// create the cell populations
include fb.g
include ff.g
include bulb.g
include connections.g		// set up the connections
include field.g			// place field potential electrodes
include output.g		// set up the outputs
include prepare.g		// set up the initial state
include savefuncs.g
include adjustweights.g 	// adjust strength of connections
include el_active.g		// enable and disable elements
include xfuncs.g 
include x_interface.g
include menu.g 


echo checking and initializing simulation
// check
echo " "
echo Piriform cortex simulation loaded.
