/*
** $Id: draw_wP.h,v 1.1 1992/12/11 19:07:09 dhb Exp $
** $Log: draw_wP.h,v $
** Revision 1.1  1992/12/11  19:07:09  dhb
** Initial revision
**
*/

#include "draw_w.h"

typedef struct _DrawClass{
  int make_compiler_happy;
}DrawClassPart;

typedef struct _DrawClassRec{
	CoreClassPart core_class;
	SimpleClassPart simple_class;
 	LabelClassPart label_class;
	DrawClassPart draw_class;
}DrawClassRec, *DrawWidgetClass;

extern DrawClassRec drawClassRec;

typedef struct {
  /* resources */
  XtCallbackList	callback;
  Pix				*icons;
  Pix				*images;
  float				cx,cy,cz;	/* Center coordinates */
  float				vx,vy,vz;	/* Viewpoint coordinates */
  float				wx,wy;		/* Window dimensions */
  char				*pixname;	/* Name of currently selected pix */
  char				*pixvalue;	/* Value of draw widget */
  int				(*transf_func)();	/* function for transforms */
  char				*refresh_flag;
  /* Private state */
  XoWhen			*when;
  Widget			w;
  Display			*display;
  Drawable			d;
  GC				gc;
} DrawPart;

typedef struct _DrawRec{
  CorePart core;
  SimplePart simple;
  LabelPart	label;
  DrawPart draw;
}DrawRec;
